/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.9 Standard
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : PPE SERRE (prof)
Version : 1 
Date    : 09/12/2010
Author  : Philippe Mariano
1, Av de Gionne 18000 BOURGES                                
Comments: PPE SERRE (programme 3)
Acquisition et affichage de l'humidit

Fichier: Humide.c

Chip type               : ATmega8535
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <mega8535.h>
#include <stdlib.h> 	// la fonction ftoa()
#include <delay.h>
#include <stdio.h>      // sprintf()

// Alphanumeric LCD Module functions
#include <alcd.h>

#define ADC_VREF_TYPE 0x60

// Read the 8 most significant bits
// of the AD conversion result
unsigned char read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCH;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here
// -----------------------------------------------------------------------------------------
//  type 		    nom 					Commentaires  
// -----------------------------------------------------------------------------------------
unsigned char U_Humidite = 0;     			// Image de l'humidit [0, 255]
float RH;					                // Valeur de l'humidit [0, 100%]
unsigned char display_buffer[17];      		// Tampon ligne 0 de l'afficheur
unsigned char Chaine_Humidite[]="00.0";
// -----------------------------------------------------------------------------------------

// ADC initialization
// ADC Clock frequency: 62,500 kHz
// ADC Voltage Reference: AVCC pin
// ADC High Speed Mode: Off
// ADC Auto Trigger Source: ADC Stopped
// Only the 8 most significant bits of
// the AD conversion result are used
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x87;
SFIOR&=0xEF;

// Alphanumeric LCD initialization
// Connections specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTC Bit 0
// RD - PORTC Bit 1
// EN - PORTC Bit 2
// D4 - PORTC Bit 4
// D5 - PORTC Bit 5
// D6 - PORTC Bit 6
// D7 - PORTC Bit 7
// Characters/line: 16
lcd_init(16);


sprintf(display_buffer," Mesure humidite" ) ;
lcd_puts(display_buffer);
delay_ms(15000);
lcd_clear();

while (1)
      {  // Dbut while                                                                                       
// ----------------------------------- Lecture de l'humidit ------------------------ 
        U_Humidite = read_adc(0);
      
// ----------------------------------- Traitement -----------------------------------  
        RH =  (float)((U_Humidite - 43)/ 1.5912); // Calcul de l'humidi
        ftoa(RH,1,Chaine_Humidite);
           
// ---------------------------------------- Affichage -------------------------------
        sprintf(display_buffer,"RH=%-s%-c",Chaine_Humidite,0x25);
        lcd_clear();
        lcd_puts(display_buffer);
        delay_ms(15000); // Mesure de l'humidit toute les 15 secondes 
// ----------------------------------------------------------------------------------
      }; // Fin while
}
